﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;

namespace DL6960_RFID_GPRS
{
    public partial class Form1 : Form
    {
       //**********************设备服务器用(device)********************************
        private Socket Socket1 = null;
        private delegate void delegate_setlist(string deviceEndPoint,string gprsname,string time);
        private delegate void delegate_showEPC(string deviceid,string gprsname,string ant, string Firsttime, string lasttime, string EPC);
        private delegate void delegate_setLed(bool value);
        private delegate void delegate_Remove(string device,bool delete);
        private delegate void delegate_showsendtoclientstate(string client,string time,string state,bool iserror);

        private delegate_setlist SetListview;
        private delegate_showEPC showEPC;
        private delegate_setLed led;
        private delegate_Remove remove;

        private bool Closesocket1 = false;
        class deviceSocket
        {
            public string RemoteEndPoint;
            public string name;
            public byte[] data;
            public string EPCstr;
            public Socket socket;
            public long lasttime;
            public bool isdelete;
            public string Handle;
        }
        private List<deviceSocket> devicesocketlist = new List<deviceSocket>();
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = this.Text + " V" + Application.ProductVersion;
            SetListview = new delegate_setlist(setListView);
            showEPC = new delegate_showEPC(SetshowEPC);
            led = new delegate_setLed(setled);
            remove = new delegate_Remove(removeitem);
           
        }
        private ListViewItem findSocketfromlistview(ListView listview, string EndPoint)
        {
            if (listview.Items.Count > 0)
            {
                ListViewItem item = listview.FindItemWithText(EndPoint);
                return item;
            }
            return null;

        }
        private void setListView(string deviceEndPoint,string gprsname,string time)
        {
            if (findSocketfromlistview(deviceList, deviceEndPoint) != null) return;
            deviceList.Items.Add(new ListViewItem(new string[] { deviceEndPoint, gprsname,deviceEndPoint}));
            label8.Text = deviceList.Items.Count.ToString();
        }
        private void removeitem(string device,bool delete)
        {
            ListViewItem item = findSocketfromlistview(deviceList, device);
            if (item != null)
            {
                if (delete)
                {
                    item.Remove();
                    label8.Text = deviceList.Items.Count.ToString();
                }
                else
                {
                    item.ForeColor = Color.Red;
                }
            }
            int index = devicesocketlist.FindIndex(
                    delegate(deviceSocket socketitem)
                    {
                        return socketitem.RemoteEndPoint == device && socketitem.isdelete;
                    });
            if (index >= 0) //找到
            {
                devicesocketlist[index].socket.Close();
                devicesocketlist[index].socket = null;
            }
        }
        private void setled(bool value)
        {
            LED1.BackColor = value ? Color.Lime : Color.Red;
        }
       

        private void btStart_Click(object sender, EventArgs e)
        {
            if (btStart.Tag.ToString() != "1")
            {
                Socket1 = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                int port;
                if (!(int.TryParse(this.Port1.Text.ToString().Trim(), out port)))
                {
                    MessageBox.Show("port error     ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Port1.Focus();
                    return;
                }
                try
                {
                    btStart.Enabled = false;
                    Closesocket1 = false;
                    IPEndPoint iep = new IPEndPoint(IPAddress.Any, port);
                    Socket1.Bind(iep);
                    Socket1.Listen(2000);
                    Socket1.BeginAccept(new AsyncCallback(Accept), Socket1);

                    LED1.Visible = true;
                    btStart.Text = "Stop";
                    btStart.Tag = 1;
                    this.Port1.Enabled = false;
                    btStart.Enabled = true;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    Port1.Focus();
                }
            }
            else
            {

                btStart.Enabled = false;
                Closesocket1 = true;
                for (int i = 0; i < devicesocketlist.Count; i++)
                {
                    if (devicesocketlist[i].socket != null) devicesocketlist[i].socket.Close();
                    Application.DoEvents();
                }
                devicesocketlist.Clear();
                Socket1.Close();
                Socket1 = null;
                deviceList.Items.Clear();

                btStart.Text = "Start";
                btStart.Tag = 0;
                Port1.Enabled = true;
                LED1.Visible = false;
                btStart.Enabled = true;
            }
        }

        private void Accept(IAsyncResult iar)
        {
            if (Closesocket1) return;
            Socket socket = (Socket)iar.AsyncState;
            try
            {
                Socket NewSocket = socket.EndAccept(iar);

                int index = -1;
                if (devicesocketlist.Count > 0)
                {
                    index = devicesocketlist.FindIndex(delegate(deviceSocket socketitem){
                           return socketitem.isdelete == true;
                       });
                }
                if (index >= 0) //找到
                {
                    devicesocketlist[index].RemoteEndPoint = NewSocket.RemoteEndPoint.ToString();
                    devicesocketlist[index].data = new byte[1024];
                    devicesocketlist[index].EPCstr = "";
                    devicesocketlist[index].socket = NewSocket;
                    devicesocketlist[index].Handle = NewSocket.Handle.ToString();
                    devicesocketlist[index].lasttime = DateTime.Now.Ticks;
                    devicesocketlist[index].isdelete = false;
                }
                else
                {
                    deviceSocket slocketone = new deviceSocket();
                    slocketone.RemoteEndPoint = NewSocket.RemoteEndPoint.ToString();
                    slocketone.data = new byte[1024];
                    slocketone.EPCstr = "";
                    slocketone.socket = NewSocket;
                    slocketone.Handle = NewSocket.Handle.ToString();
                    slocketone.lasttime = DateTime.Now.Ticks;
                    slocketone.isdelete = false;
                    devicesocketlist.Add(slocketone);
                    index = devicesocketlist.Count - 1;
                }
                NewSocket.BeginReceive(devicesocketlist[index].data, 0, 1024, SocketFlags.None, new AsyncCallback(Receive), NewSocket);
            }
            catch //(Exception err)
            {
                this.Invoke(led, new object[] { false });
               // MessageBox.Show(err.Message);
            }
            Thread.Sleep(200);
            if(socket!=null) socket.BeginAccept(new AsyncCallback(Accept), socket);
        }

        private void Receive(IAsyncResult iar)
        {
            if (Closesocket1) return;

            Socket OtherSocket = (Socket)iar.AsyncState;
             deviceSocket socketitem=null;
            string deviceEndPoint ="";
            try
            {
                if (OtherSocket.Connected == false) return;
                deviceEndPoint = OtherSocket.RemoteEndPoint.ToString();
                this.Invoke(led, new object[] { true });

                if (devicesocketlist.Count > 0)
                {
                    socketitem = devicesocketlist.FindLast(delegate(deviceSocket Socketitem)
                    {
                        return Socketitem.RemoteEndPoint == OtherSocket.RemoteEndPoint.ToString() && Socketitem.isdelete == false;
                    });
                    if (socketitem != null) //找到
                    {
                        int Len = OtherSocket.EndReceive(iar);
                        if (Len == 0)
                        {
                            socketitem.isdelete = true;
                            this.Invoke(remove, new object[] { deviceEndPoint,true});
                            return;
                        }

                        socketitem.lasttime = DateTime.Now.Ticks;
                        bool isEPCdata = true;
                         if (Len == 4)
                        {
                            if (socketitem.data[0] == 48 && socketitem.data[1] == 48 && socketitem.data[2] == 48 && socketitem.data[3] == 48) //heartbeat string
                                isEPCdata = false;
                        }
                        else if (socketitem.data[0] == 76 && socketitem.data[1] == 79) //LO    Login
                        {
                            if (socketitem.data[2] == 71 && socketitem.data[3] == 73 && socketitem.data[4] == 78 && socketitem.data[5] == 58) //GIN:
                            {
                                if (Len > 40) Len = 40;
                                string gprsname = Encoding.Default.GetString(socketitem.data, 0, Len).Substring(6);
                                if (gprsname.IndexOf('\\') > 0) gprsname = gprsname.Substring(0, gprsname.IndexOf('\\'));
                                socketitem.name = gprsname;
                                this.Invoke(SetListview, new object[] { deviceEndPoint, gprsname, DateTime.Now.ToString() });

                                int oldindex = devicesocketlist.FindIndex(delegate(deviceSocket Socketitem)
                                {
                                    return Socketitem.name == gprsname && Socketitem.Handle != OtherSocket.Handle.ToString() && Socketitem.isdelete == false;
                                });
                                if (oldindex >= 0) //same gprs id
                                {
                                    this.Invoke(remove, new object[] {devicesocketlist[oldindex].RemoteEndPoint, false});
                                }

                                isEPCdata = false;
                            }
                        }

                        if (isEPCdata)
                        {
                            byte[] data = new byte[Len];
                            Array.Copy(socketitem.data, 0, data, 0, Len);
                            Analysisdata(data, socketitem);
                        }
                        Array.Clear(socketitem.data, 0, Len);
                        OtherSocket.BeginReceive(socketitem.data, 0, 1024, SocketFlags.None, new AsyncCallback(Receive), OtherSocket);
                    }
                }
            }
            catch// (SocketException err)
            {
                if (socketitem != null && deviceEndPoint != "")
                {
                    socketitem.isdelete = true;
                    this.Invoke(remove, new object[] { deviceEndPoint,true});
                }
            }
            finally
            {
                this.Invoke(led, new object[] { false });
            }
        }
        private void SetshowEPC(string deviceid,string gprsname,string ant,string firsttime,string lasttime,string EPC) 
        {
            label2.Text = (long.Parse(label2.Text) + 1).ToString();

            EPClistView.Rows.Add(new string[] { (EPClistView.RowCount + 1).ToString(), deviceid, gprsname, ant, firsttime, lasttime, EPC });
            if (checkBox2.Checked)
            {
                EPClistView.Rows[EPClistView.Rows.Count - 1].Selected = true;
                EPClistView.FirstDisplayedScrollingRowIndex = EPClistView.RowCount - 1;
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            EPClistView.Rows.Clear();
            label2.Text = "0";
        }

        private void tbPort_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789\b".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            btStart_Click(null, null);
        }

        private void mainform_FormClosing(object sender, FormClosingEventArgs e)
        {
            Closesocket1 = true;
        }
        private void label2_DoubleClick(object sender, EventArgs e)
        {
            label2.Text = "0";
        }
        /*********************************************************************************************/
        public static byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        public static string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();

        }
        private bool CheckCRC(string s)
        {
            int i, j;
            int current_crc_value;
            byte crcL, crcH;
            byte[] data = HexStringToByteArray(s);
            current_crc_value = 0xFFFF;
            for (i = 0; i <= (data.Length - 1); i++)
            {
                current_crc_value = current_crc_value ^ (data[i]);
                for (j = 0; j < 8; j++)
                {
                    if ((current_crc_value & 0x01) != 0)
                        current_crc_value = (current_crc_value >> 1) ^ 0x8408;
                    else
                        current_crc_value = (current_crc_value >> 1);
                }
            }
            crcL = Convert.ToByte(current_crc_value & 0xFF);
            crcH = Convert.ToByte((current_crc_value >> 8) & 0xFF);
            if (crcH == 0 && crcL == 0)
            {
                return true;
            }
            else
            {
                return false;
            }

        }
        private void Analysisdata(byte[] daw, deviceSocket item)
        {
            int nLen, NumLen;
            string temp1 = "";
            string syear = "";
            string smonth = "";
            string sday = "";
            string shour = "";
            string smin = "";
            string ssec = "";
            string Lyear = "";
            string Lmonth = "";
            string Lday = "";
            string Lhour = "";
            string Lmin = "";
            string Lsec = "";
            string binarystr1 = "";
            string binarystr2 = "";
            string CountStr = "";
            string AntStr = "";
            string EPCStr = "";
            string temp;
            string firsttime, lasttime, deviceid;
            try
            {
                temp = ByteArrayToHexString(daw);
                item.EPCstr = item.EPCstr + temp;//把字符串存进列表
                nLen = item.EPCstr.Length;
                while (item.EPCstr.Length > 34)
                {
                    string FlagStr ="EE00";//查找头位置标志字符串
                    int nindex = item.EPCstr.IndexOf(FlagStr);
                    if (nindex > 3)
                    {
                        item.EPCstr = item.EPCstr.Substring(nindex - 4);
                        deviceid = item.EPCstr.Substring(2, 2);
                    }
                    else
                    {
                        item.EPCstr = item.EPCstr.Substring(2);
                        continue;
                    }
                    NumLen = Convert.ToInt32(item.EPCstr.Substring(0, 2), 16) * 2 + 2;//取第一个帧的长度
                    if (item.EPCstr.Length < NumLen)
                    {
                        break;
                    }
                    temp1 = item.EPCstr.Substring(0, NumLen);
                    item.EPCstr = item.EPCstr.Substring(NumLen);
                    if (!CheckCRC(temp1)) continue;
                    binarystr1 = Convert.ToString(Convert.ToInt32(temp1.Substring(8, 8), 16), 2).PadLeft(32, '0');
                    syear = Convert.ToString(Convert.ToInt32(binarystr1.Substring(0, 6), 2)).PadLeft(2, '0');
                    smonth = Convert.ToString(Convert.ToInt32(binarystr1.Substring(6, 4), 2)).PadLeft(2, '0');
                    sday = Convert.ToString(Convert.ToInt32(binarystr1.Substring(10, 5), 2)).PadLeft(2, '0');
                    shour = Convert.ToString(Convert.ToInt32(binarystr1.Substring(15, 5), 2)).PadLeft(2, '0');
                    smin = Convert.ToString(Convert.ToInt32(binarystr1.Substring(20, 6), 2)).PadLeft(2, '0');
                    ssec = Convert.ToString(Convert.ToInt32(binarystr1.Substring(26, 6), 2)).PadLeft(2, '0');

                    binarystr2 = Convert.ToString(Convert.ToInt32(temp1.Substring(16, 8), 16), 2).PadLeft(32, '0');
                    Lyear = Convert.ToString(Convert.ToInt32(binarystr2.Substring(0, 6), 2)).PadLeft(2, '0');
                    Lmonth = Convert.ToString(Convert.ToInt32(binarystr2.Substring(6, 4), 2)).PadLeft(2, '0');
                    Lday = Convert.ToString(Convert.ToInt32(binarystr2.Substring(10, 5), 2)).PadLeft(2, '0');
                    Lhour = Convert.ToString(Convert.ToInt32(binarystr2.Substring(15, 5), 2)).PadLeft(2, '0');
                    Lmin = Convert.ToString(Convert.ToInt32(binarystr2.Substring(20, 6), 2)).PadLeft(2, '0');
                    Lsec = Convert.ToString(Convert.ToInt32(binarystr2.Substring(26, 6), 2)).PadLeft(2, '0');

                    CountStr = Convert.ToString(Convert.ToInt32(temp1.Substring(24, 4), 16), 10);
                    AntStr = Convert.ToString(Convert.ToInt32(temp1.Substring(28, 2), 16), 2).PadLeft(4, '0');
                    EPCStr = temp1.Substring(30, temp1.Length - 34).Substring(2);

                    firsttime= "20" + syear + "-" + smonth + "-" + sday + " " + shour + ":" + smin + ":" + ssec;
                    lasttime = "20" + Lyear + "-" + Lmonth + "-" + Lday + " " + Lhour + ":" + Lmin + ":" + Lsec;
                    this.Invoke(showEPC, new object[] { deviceid, item.name, AntStr, firsttime, lasttime, EPCStr });
                }
            }
            catch (System.Exception ex)
            {
                ex.ToString();
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            timer2.Enabled = false;
            long nowtime = DateTime.Now.Ticks;
            for (int i = devicesocketlist.Count - 1; i >= 0; i--)
            {
                if (devicesocketlist[i].isdelete) continue;
                if (devicesocketlist[i].RemoteEndPoint == "") continue;

                if ((nowtime - devicesocketlist[i].lasttime) / 10000000 > 180) // 180=3 Minute
                {
                    devicesocketlist[i].isdelete = true;
                    this.Invoke(remove, new object[] { devicesocketlist[i].RemoteEndPoint,true});
                }
            }
            timer2.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (EPClistView.Rows.Count == 0) return;
            
            SaveFileDialog savetofile = new SaveFileDialog();
            savetofile.Title = "Export";
            savetofile.Filter = "HTML(*.html)|*.html";
            savetofile.FileName = "EPClist.html";
            if (savetofile.ShowDialog(this) == DialogResult.OK)
            {
                button2.Enabled = false;
                this.Cursor = Cursors.WaitCursor;
                string filename = savetofile.FileName;
                try
                {

                    int width = EPClistView.Width;
                    string colwidth ="";

                    StreamWriter file = new StreamWriter(filename, false,System.Text.Encoding.UTF8);
                    string context = "<table width='100%' border='1' cellpadding='5' cellspacing='0' bordercolor='#DCDCDC' bgcolor='#FFFFFF' style='border-collapse:collapse;pa'>";
                    file.WriteLine(context);

                    context = "<tr height='30px'>";
                    file.WriteLine(context);
                    for (int col = 0; col < EPClistView.ColumnCount; col++)
                    {
                        colwidth =((EPClistView.Columns[col].Width+0.1) / width).ToString("0%");
                        context = "<td " + (col < EPClistView.ColumnCount - 1 ? "width='" + colwidth+"'" : "") + " bgcolor='#f1f1f1'>" + EPClistView.Columns[col].HeaderText + "</td>";
                        file.WriteLine(context);
                    }
                    context = "</tr>";
                    file.WriteLine(context);

                    for (int row = 0; row < EPClistView.Rows.Count; row++)
                    {
                        context = "<tr height='25px'>";
                        file.WriteLine(context);
                        for (int col = 0; col < EPClistView.ColumnCount; col++)
                        {
                            context = "<td>"+ EPClistView[col,row].Value.ToString () +"</td>";
                            file.WriteLine(context);
                        }
                        context = "</tr>";
                        file.WriteLine(context);

                    }
                    context="</table>";
                    file.WriteLine(context);

                    file.Close();
                    System.Diagnostics.Process.Start(filename);
                }
                finally
                {
                    button2.Enabled = true;
                    this.Cursor = Cursors.Default;
                }
            }

        }
    }
}